/*
 * see https://www.simtech-ag.ch/education/java/jpf2/resources/lambda/validator
 * author: Daniel Schmutz
 * copyright: Simtech AG (https://www.simtech-ag.ch)
 */

package ch.std.jup8.lambda.validator.classic;

public enum StringValidatorEnum {

	STRING_8 {
		@Override
		public void validate(String s) throws ValidatorException {
			if (s instanceof String) {
				System.out.println();
			}
			if (s.length() > 8) {
				throw new ValidatorException(this.name());
			}
		}		
	},
	STRING_16 {
		@Override
		public void validate(String s) throws ValidatorException {
			if (s.length() > 16) {
				throw new ValidatorException(this.name());
			}
		}		
	},
	STRING_32 {
		@Override
		public void validate(String s) throws ValidatorException {
			if (s.length() > 32) {
				throw new ValidatorException(this.name());
			}
		}		
	};
	private StringValidatorEnum() {
		
	}
	public abstract void validate(String s) throws ValidatorException;
}