/*
 * see https://www.simtech-ag.ch/education/java/jpf2/resources/tiger/worditerable
 * author: Daniel Schmutz
 * copyright: Simtech AG (https://www.simtech-ag.ch)
 */

package ch.std.jpf2.tiger.worditerable;

import java.util.Iterator;

class WordIterable implements Iterable<String> {

	private String[] words;

	public WordIterable(String s) {
		this.words = s.split("[\\s']");
	}

	@Override
	public Iterator<String> iterator() {
		return new WordIterator();
	}

	private class WordIterator implements Iterator<String> {// member class
		private int pos = -1;

		@Override
		public boolean hasNext() {
			return this.pos < WordIterable.this.words.length - 1;
		}

		@Override
		public String next() {
			return WordIterable.this.words[++this.pos]; // pre increment
		}

		@Override
		public void remove() {
			throw new UnsupportedOperationException();
		}

	}
}

